AsyncListener (Servlet 6.1 API Documentation - Apache Tomcat 11.0.23)
Description: declaration: package: jakarta.servlet, interface: AsyncListener

# Interface AsyncListener

All Superinterfaces:
  `EventListener`

public interface AsyncListener extends EventListener
Listener for events associated with an `AsyncContext`.

Since:
  Servlet 3.0

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `onComplete(AsyncEvent event)`
  This event is fired after the call to `AsyncContext.complete()` has been processed by the container.
  `void`
  `onError(AsyncEvent event)`
  This event is fired if an error occurs during an asynchronous operation but before the container takes any action as a result of the error.
  `void`
  `onStartAsync(AsyncEvent event)`
  This event is fired if new call is made to `ServletRequest.startAsync()` after the completion of the `AsyncContext` to which this listener was added.
  `void`
  `onTimeout(AsyncEvent event)`
  This event is fired if an asynchronous operation times out but before the container takes any action as a result of the timeout.

- ## Method Details

  - ### onComplete

    void onComplete(AsyncEvent event) throws IOException
    This event is fired after the call to `AsyncContext.complete()` has been processed by the container.
    Parameters:
      `event` - Provides access to the objects associated with the event
    Throws:
      `IOException` - Should be thrown if an I/O error occurs during the processing of the event

  - ### onTimeout

    void onTimeout(AsyncEvent event) throws IOException
    This event is fired if an asynchronous operation times out but before the container takes any action as a result of the timeout.
    Parameters:
      `event` - Provides access to the objects associated with the event
    Throws:
      `IOException` - Should be thrown if an I/O error occurs during the processing of the event

  - ### onError

    void onError(AsyncEvent event) throws IOException
    This event is fired if an error occurs during an asynchronous operation but before the container takes any action as a result of the error.
    Parameters:
      `event` - Provides access to the objects associated with the event
    Throws:
      `IOException` - Should be thrown if an I/O error occurs during the processing of the event

  - ### onStartAsync

    void onStartAsync(AsyncEvent event) throws IOException
    This event is fired if new call is made to `ServletRequest.startAsync()` after the completion of the `AsyncContext` to which this listener was added.
    Parameters:
      `event` - Provides access to the objects associated with the event
    Throws:
      `IOException` - Should be thrown if an I/O error occurs during the processing of the event